---
title: Batch update LLM Observability dataset records
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > LLM Observability
---

# Batch update LLM Observability dataset records{% #batch-update-llm-observability-dataset-records %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                                         |
| ----------------- | ---------------------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |

### Overview

Insert, update, and delete records in a single dataset operation. By default, a new dataset version is created when the batch is applied.

### Arguments

#### Path Parameters

| Name                         | Type   | Description                              |
| ---------------------------- | ------ | ---------------------------------------- |
| project_id [*required*] | string | The ID of the LLM Observability project. |
| dataset_id [*required*] | string | The ID of the LLM Observability dataset. |

### Request

#### Body Data (required)

Batch update payload.

{% tab title="Model" %}

| Parent field    | Field                        | Type                | Description                                                                                                                                                                                        |
| --------------- | ---------------------------- | ------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                 | data [*required*]       | object              | Data object for batch-updating records in an LLM Observability dataset.                                                                                                                            |
| data            | attributes [*required*] | object              | Attributes for batch-updating records in an LLM Observability dataset.                                                                                                                             |
| attributes      | create_new_version           | boolean             | Whether to create a new dataset version when applying the batch update. Defaults to `true`.                                                                                                        |
| attributes      | delete_records               | [string]            | Record IDs to delete.                                                                                                                                                                              |
| attributes      | insert_records               | [object]            | Records to insert.                                                                                                                                                                                 |
| insert_records  | expected_output              | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| expected_output | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| expected_output | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| expected_output | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| expected_output | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| expected_output | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| insert_records  | id                           | string              | Optional user-provided identifier for the record. If omitted, the server generates an identifier.                                                                                                  |
| insert_records  | input [*required*]      | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| input           | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| input           | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| input           | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| input           | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| input           | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| insert_records  | metadata                     | object              | Arbitrary metadata associated with the record.                                                                                                                                                     |
| insert_records  | tag_operations               | object              | Explicit tag operations for updating records. Operations are applied in order, Remove then Add then Set. `set` is the final override; if specified, the result of `remove` and `add` is discarded. |
| tag_operations  | add                          | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | remove                       | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | set                          | [string]            | List of tag strings.                                                                                                                                                                               |
| insert_records  | tags                         | [string]            | List of tag strings.                                                                                                                                                                               |
| attributes      | tags                         | [string]            | List of tag strings.                                                                                                                                                                               |
| attributes      | update_records               | [object]            | Records to update by ID.                                                                                                                                                                           |
| update_records  | expected_output              | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| expected_output | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| expected_output | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| expected_output | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| expected_output | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| expected_output | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| update_records  | id [*required*]         | string              | Unique identifier of the record to update.                                                                                                                                                         |
| update_records  | input                        | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| input           | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| input           | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| input           | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| input           | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| input           | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| update_records  | metadata                     | object              | Updated metadata associated with the record.                                                                                                                                                       |
| update_records  | tag_operations               | object              | Explicit tag operations for updating records. Operations are applied in order, Remove then Add then Set. `set` is the final override; if specified, the result of `remove` and `add` is discarded. |
| tag_operations  | add                          | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | remove                       | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | set                          | [string]            | List of tag strings.                                                                                                                                                                               |
| data            | id [*required*]         | string              | Unique identifier of the dataset.                                                                                                                                                                  |
| data            | type [*required*]       | enum                | Resource type of an LLM Observability dataset. Allowed enum values: `datasets`                                                                                                                     |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "create_new_version": true,
      "delete_records": [],
      "insert_records": [
        {
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "tag_operations": {
            "add": [],
            "remove": [],
            "set": []
          },
          "tags": []
        }
      ],
      "tags": [],
      "update_records": [
        {
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "tag_operations": {
            "add": [],
            "remove": [],
            "set": []
          }
        }
      ]
    },
    "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    "type": "datasets"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing records after a create or update operation.

| Parent field    | Field                             | Type                | Description                                           |
| --------------- | --------------------------------- | ------------------- | ----------------------------------------------------- |
|                 | data [*required*]            | [object]            | List of affected dataset records.                     |
| data            | records [*required*]         | [object]            | List of affected dataset records.                     |
| records         | created_at [*required*]      | date-time           | Timestamp when the record was created.                |
| records         | dataset_id [*required*]      | string              | Identifier of the dataset this record belongs to.     |
| records         | expected_output [*required*] | object <oneOf> | Represents any valid JSON value.                      |
| expected_output | Option 1                          | string              | A scalar string value.                                |
| expected_output | Option 2                          | double              | A scalar numeric value.                               |
| expected_output | Option 3                          | object              | An arbitrary object value with additional properties. |
| expected_output | Option 4                          | [ <oneOf>]     | An array of arbitrary values.                         |
| Option 4        | Option 1                          | string              | A scalar string value.                                |
| Option 4        | Option 2                          | double              | A scalar numeric value.                               |
| Option 4        | Option 3                          | object              | An arbitrary object value with additional properties. |
| Option 4        | Option 4                          | boolean             | A scalar boolean value.                               |
| expected_output | Option 5                          | boolean             | A scalar boolean value.                               |
| records         | id [*required*]              | string              | Unique identifier of the record.                      |
| records         | input [*required*]           | object <oneOf> | Represents any valid JSON value.                      |
| input           | Option 1                          | string              | A scalar string value.                                |
| input           | Option 2                          | double              | A scalar numeric value.                               |
| input           | Option 3                          | object              | An arbitrary object value with additional properties. |
| input           | Option 4                          | [ <oneOf>]     | An array of arbitrary values.                         |
| Option 4        | Option 1                          | string              | A scalar string value.                                |
| Option 4        | Option 2                          | double              | A scalar numeric value.                               |
| Option 4        | Option 3                          | object              | An arbitrary object value with additional properties. |
| Option 4        | Option 4                          | boolean             | A scalar boolean value.                               |
| input           | Option 5                          | boolean             | A scalar boolean value.                               |
| records         | metadata [*required*]        | object              | Arbitrary metadata associated with the record.        |
| records         | updated_at [*required*]      | date-time           | Timestamp when the record was last updated.           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "records": [
        {
          "created_at": "2024-01-15T10:30:00Z",
          "dataset_id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "updated_at": "2024-01-15T10:30:00Z"
        }
      ]
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="413" %}
Payload Too Large
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export project_id="a33671aa-24fd-4dcd-9b33-a8ec7dde7751" export dataset_id="9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/llm-obs/v1/${project_id}/datasets/${dataset_id}/batch_update" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "create_new_version": true,
      "delete_records": [
        "rec-old-record-1"
      ],
      "insert_records": [
        {
          "expected_output": {
            "answer": "Paris"
          },
          "input": {
            "question": "What is the capital of France?"
          },
          "tags": [
            "topic:geography"
          ]
        }
      ],
      "update_records": [
        {
          "expected_output": {
            "answer": "Paris, France"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c"
        }
      ]
    },
    "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    "type": "datasets"
  }
}
EOF 
                
##### 

```python
"""
Batch update LLM Observability dataset records returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.llm_observability_api import LLMObservabilityApi
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_data_attributes_request import (
    LLMObsDatasetBatchUpdateDataAttributesRequest,
)
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_data_request import LLMObsDatasetBatchUpdateDataRequest
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_insert_record import LLMObsDatasetBatchUpdateInsertRecord
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_request import LLMObsDatasetBatchUpdateRequest
from datadog_api_client.v2.model.llm_obs_dataset_batch_update_update_record import LLMObsDatasetBatchUpdateUpdateRecord
from datadog_api_client.v2.model.llm_obs_dataset_record_tag_operations import LLMObsDatasetRecordTagOperations
from datadog_api_client.v2.model.llm_obs_dataset_type import LLMObsDatasetType

body = LLMObsDatasetBatchUpdateRequest(
    data=LLMObsDatasetBatchUpdateDataRequest(
        attributes=LLMObsDatasetBatchUpdateDataAttributesRequest(
            create_new_version=True,
            delete_records=[],
            insert_records=[
                LLMObsDatasetBatchUpdateInsertRecord(
                    expected_output=None,
                    id="rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
                    input=None,
                    tag_operations=LLMObsDatasetRecordTagOperations(
                        add=[],
                        remove=[],
                        set=[],
                    ),
                    tags=[],
                ),
            ],
            tags=[],
            update_records=[
                LLMObsDatasetBatchUpdateUpdateRecord(
                    expected_output=None,
                    id="rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
                    input=None,
                    tag_operations=LLMObsDatasetRecordTagOperations(
                        add=[],
                        remove=[],
                        set=[],
                    ),
                ),
            ],
        ),
        id="9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
        type=LLMObsDatasetType.DATASETS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["batch_update_llm_obs_dataset"] = True
with ApiClient(configuration) as api_client:
    api_instance = LLMObservabilityApi(api_client)
    response = api_instance.batch_update_llm_obs_dataset(project_id="project_id", dataset_id="dataset_id", body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Batch update LLM Observability dataset records returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.batch_update_llm_obs_dataset".to_sym] = true
end
api_instance = DatadogAPIClient::V2::LLMObservabilityAPI.new

body = DatadogAPIClient::V2::LLMObsDatasetBatchUpdateRequest.new({
  data: DatadogAPIClient::V2::LLMObsDatasetBatchUpdateDataRequest.new({
    attributes: DatadogAPIClient::V2::LLMObsDatasetBatchUpdateDataAttributesRequest.new({
      create_new_version: true,
      delete_records: [],
      insert_records: [
        DatadogAPIClient::V2::LLMObsDatasetBatchUpdateInsertRecord.new({
          expected_output: nil,
          id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          input: nil,
          tag_operations: DatadogAPIClient::V2::LLMObsDatasetRecordTagOperations.new({
            add: [],
            remove: [],
            set: [],
          }),
          tags: [],
        }),
      ],
      tags: [],
      update_records: [
        DatadogAPIClient::V2::LLMObsDatasetBatchUpdateUpdateRecord.new({
          expected_output: nil,
          id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          input: nil,
          tag_operations: DatadogAPIClient::V2::LLMObsDatasetRecordTagOperations.new({
            add: [],
            remove: [],
            set: [],
          }),
        }),
      ],
    }),
    id: "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    type: DatadogAPIClient::V2::LLMObsDatasetType::DATASETS,
  }),
})
p api_instance.batch_update_llm_obs_dataset("project_id", "dataset_id", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Batch update LLM Observability dataset records returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.LLMObsDatasetBatchUpdateRequest{
		Data: datadogV2.LLMObsDatasetBatchUpdateDataRequest{
			Attributes: datadogV2.LLMObsDatasetBatchUpdateDataAttributesRequest{
				CreateNewVersion: datadog.PtrBool(true),
				DeleteRecords:    []string{},
				InsertRecords: []datadogV2.LLMObsDatasetBatchUpdateInsertRecord{
					{
						ExpectedOutput: *datadogV2.NewNullableAnyValue(nil),
						Id:             datadog.PtrString("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c"),
						Input:          *datadogV2.NewNullableAnyValue(nil),
						TagOperations: &datadogV2.LLMObsDatasetRecordTagOperations{
							Add:    []string{},
							Remove: []string{},
							Set:    []string{},
						},
						Tags: []string{},
					},
				},
				Tags: []string{},
				UpdateRecords: []datadogV2.LLMObsDatasetBatchUpdateUpdateRecord{
					{
						ExpectedOutput: *datadogV2.NewNullableAnyValue(nil),
						Id:             "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
						Input:          *datadogV2.NewNullableAnyValue(nil),
						TagOperations: &datadogV2.LLMObsDatasetRecordTagOperations{
							Add:    []string{},
							Remove: []string{},
							Set:    []string{},
						},
					},
				},
			},
			Id:   "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
			Type: datadogV2.LLMOBSDATASETTYPE_DATASETS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.BatchUpdateLLMObsDataset", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewLLMObservabilityApi(apiClient)
	resp, r, err := api.BatchUpdateLLMObsDataset(ctx, "project_id", "dataset_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `LLMObservabilityApi.BatchUpdateLLMObsDataset`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `LLMObservabilityApi.BatchUpdateLLMObsDataset`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Batch update LLM Observability dataset records returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.LlmObservabilityApi;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateDataAttributesRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateDataRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateInsertRecord;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateRequest;
import com.datadog.api.client.v2.model.LLMObsDatasetBatchUpdateUpdateRecord;
import com.datadog.api.client.v2.model.LLMObsDatasetRecordTagOperations;
import com.datadog.api.client.v2.model.LLMObsDatasetRecordsMutationResponse;
import com.datadog.api.client.v2.model.LLMObsDatasetType;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.batchUpdateLLMObsDataset", true);
    LlmObservabilityApi apiInstance = new LlmObservabilityApi(defaultClient);

    LLMObsDatasetBatchUpdateRequest body =
        new LLMObsDatasetBatchUpdateRequest()
            .data(
                new LLMObsDatasetBatchUpdateDataRequest()
                    .attributes(
                        new LLMObsDatasetBatchUpdateDataAttributesRequest()
                            .createNewVersion(true)
                            .insertRecords(
                                Collections.singletonList(
                                    new LLMObsDatasetBatchUpdateInsertRecord()
                                        .expectedOutput(null)
                                        .id("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c")
                                        .input(null)
                                        .tagOperations(new LLMObsDatasetRecordTagOperations())))
                            .updateRecords(
                                Collections.singletonList(
                                    new LLMObsDatasetBatchUpdateUpdateRecord()
                                        .expectedOutput(null)
                                        .id("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c")
                                        .input(null)
                                        .tagOperations(new LLMObsDatasetRecordTagOperations()))))
                    .id("9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d")
                    .type(LLMObsDatasetType.DATASETS));

    try {
      LLMObsDatasetRecordsMutationResponse result =
          apiInstance.batchUpdateLLMObsDataset(
              "a33671aa-24fd-4dcd-9b33-a8ec7dde7751", "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling LlmObservabilityApi#batchUpdateLLMObsDataset");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Batch update LLM Observability dataset records returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_llm_observability::LLMObservabilityAPI;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateDataAttributesRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateDataRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateInsertRecord;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateRequest;
use datadog_api_client::datadogV2::model::LLMObsDatasetBatchUpdateUpdateRecord;
use datadog_api_client::datadogV2::model::LLMObsDatasetRecordTagOperations;
use datadog_api_client::datadogV2::model::LLMObsDatasetType;

#[tokio::main]
async fn main() {
    let body = LLMObsDatasetBatchUpdateRequest::new(LLMObsDatasetBatchUpdateDataRequest::new(
        LLMObsDatasetBatchUpdateDataAttributesRequest::new()
            .create_new_version(true)
            .delete_records(vec![])
            .insert_records(vec![LLMObsDatasetBatchUpdateInsertRecord::new(None)
                .expected_output(None)
                .id("rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c".to_string())
                .tag_operations(
                    LLMObsDatasetRecordTagOperations::new()
                        .add(vec![])
                        .remove(vec![])
                        .set(vec![]),
                )
                .tags(vec![])])
            .tags(vec![])
            .update_records(vec![LLMObsDatasetBatchUpdateUpdateRecord::new(
                "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c".to_string(),
            )
            .expected_output(None)
            .input(None)
            .tag_operations(
                LLMObsDatasetRecordTagOperations::new()
                    .add(vec![])
                    .remove(vec![])
                    .set(vec![]),
            )]),
        "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d".to_string(),
        LLMObsDatasetType::DATASETS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.BatchUpdateLLMObsDataset", true);
    let api = LLMObservabilityAPI::with_config(configuration);
    let resp = api
        .batch_update_llm_obs_dataset("project_id".to_string(), "dataset_id".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Batch update LLM Observability dataset records returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.batchUpdateLLMObsDataset"] = true;
const apiInstance = new v2.LLMObservabilityApi(configuration);

const params: v2.LLMObservabilityApiBatchUpdateLLMObsDatasetRequest = {
  body: {
    data: {
      attributes: {
        createNewVersion: true,
        deleteRecords: [],
        insertRecords: [
          {
            expectedOutput: undefined,
            id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
            input: null,
            tagOperations: {
              add: [],
              remove: [],
              set: [],
            },
            tags: [],
          },
        ],
        tags: [],
        updateRecords: [
          {
            expectedOutput: undefined,
            id: "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
            input: undefined,
            tagOperations: {
              add: [],
              remove: [],
              set: [],
            },
          },
        ],
      },
      id: "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
      type: "datasets",
    },
  },
  projectId: "project_id",
  datasetId: "dataset_id",
};

apiInstance
  .batchUpdateLLMObsDataset(params)
  .then((data: v2.LLMObsDatasetRecordsMutationResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
